#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

const int MIN_N = 2;
const int MAX_N = 1e5;
const int MIN_T = 1;
const int MAX_T = 1000;

const int rnd_test_n = 100;

template <typename T> void append(vector<T> &dest, const vector<T> &orig) {
	dest.insert(dest.end(), orig.begin(), orig.end());
}

string output_tc(const vector<int> &nums) {
	ostringstream oss;
    oss << nums.size() << endl;
    for (int i = 0; i < nums.size(); i++) {
        if (i != 0) oss << " ";
        oss << nums[i];
    }
    oss << endl;
	return oss.str();
}

vector<string> generate_sample_tests() {
	vector<string> tests;
    tests.push_back(output_tc({1, 5, 3, 4, 2}));
    tests.push_back(output_tc({5, 1, 3, 4, 2}));
    tests.push_back(output_tc({1, 2, 3, 4, 5}));
	return tests;
}

vector<string> generate_manual_tests() {
    vector<string> tests;
    tests.push_back(output_tc({2, 1, 4, 3, 6, 5, 8, 7, 10, 9}));
    tests.push_back(output_tc({10, 1, 8, 3, 6, 5, 4, 7, 2, 9}));
	return tests;
}

vector<int> generateSequence(int size) {
    vector<int> seq = rnd.perm(size, 1);
    return seq;
}

string rnd_test(int i){
    int min_n = MIN_N;
    int max_n = MAX_N;
    
    if(i<rnd_test_n / 3){
        max_n = 500;
    }
    else if(i<rnd_test_n / 2){
        max_n = 20000;
    }

    int n = rnd.next(min_n, max_n);
    return(output_tc(generateSequence(n)));
}

vector<string> generate_random_tests() { 
    vector<string> tests;
    for (int i = 0; i < rnd_test_n; i++){
        tests.push_back(rnd_test(i));
    } 
    return tests;
}

string extreme_test_1(){
    return(output_tc(generateSequence(MAX_N)));
}

string extreme_test_2(){
    vector<int> seq(MAX_N);
    for (int i = 0; i < MAX_N; i++) {
        seq[i] = MAX_N - i;
    }
    return(output_tc(seq));
}

vector<string> generate_extreme_tests(){
    vector<string> tests;   
    tests.push_back(extreme_test_1());
    tests.push_back(extreme_test_2());
    return tests;
}

int main(int argc, char *argv[]) {
	registerGen(argc, argv, 1);
	vector<string> tests;
	size_t test = 0;
	append(tests, generate_sample_tests());
	append(tests, generate_manual_tests());
	append(tests, generate_random_tests());
	append(tests, generate_extreme_tests());
	for (const auto &t : tests) {
		startTest(++test);
		cout << t;
	}
	return 0;
}